//Serena Bailey ITDEV110 Downtown Campus
package bailey_guesstheword;

import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;
import javax.sound.sampled.LineUnavailableException;

public class Board {
    //all declarations for the game.
    String [] myWordListArray = {"foxes", "kitty", "elephant", "picture", "candles", "seventeen", "boots", "children", "microwave", "couch"};
    
    String thisword;
    int MAX = 10;
    int MIN = 1;
    int MAX_GUESSES = 7;
    int guessCounter = 0;
    
    char holdChar;
    char [] aWord;
    char [] wordInPlayArray;
    char [] boardInPlayArray;
    
    ArrayList <Character> badGuessArray = new ArrayList();
    
    Random rand = new Random();
    Scanner keyboard = new Scanner (System.in);
    Sounder s = new Sounder();
    Admin a = new Admin();
    
    public void gameSetup() throws IOException, LineUnavailableException, InterruptedException
    {
        //where the set up for the game itself is being made.
        Controller c = new Controller();
        
        thisword = myWordListArray[rand.nextInt(MAX - MIN) + 1];
        aWord = new char [thisword.length()];
        wordInPlayArray = new char [thisword.length()];
        boardInPlayArray = new char [thisword.length()];
        
        StringReader readstring = new StringReader (thisword);
        
        readstring.read(aWord, 0, thisword.length());
        
        for (int x = 0; x < aWord.length; x++)
        {
            wordInPlayArray[x] = aWord[x];
        }
        
        System.out.println();
        
        for (int i = 0; i < aWord.length; i++)
        {
            System.out.print("\t\t[ ]");
        }
        
        System.out.println();
        guessCounter = 0;
        
        do {
            getGuessFromUser();
            
            if (holdChar == '0')
            {
                c.quit = true;
                System.out.println("Thank you for playing.");
                return;
            }
            
            isGuessValid();
            displayGameBoard();
            displayBadGuesses();
            checkForWinner();
        } while (holdChar != '0');
    }
    
    public void getGuessFromUser() throws LineUnavailableException, InterruptedException, IOException
    {
        //where you will get the guess from the user for the game.
        if (guessCounter < 7)
        {
            System.out.println("\n\nEnter guess or 0 to quit: ");
            holdChar = keyboard.next().toLowerCase().charAt(0);
        }
        else
        {
            s.playLoserSound();
            System.out.println("\nYou're out of guesses! Game Over!");
            System.out.println("Do you want to play again? y or n?");
            a.goodbye();
            
            holdChar = '0';
        }
    }
    
    public void isGuessValid() throws LineUnavailableException
    {
        //what to do if the guess is valid (correct)
        boolean bad;
        
        bad = badGuessArray.contains(holdChar);
        
        if (bad)
        {
            System.out.println("You already guessed" + holdChar);
            s.playAlreadyGuessedSound();
        }
        else
        {
            handleMatch();
        }
    }
    
    public void handleMatch() throws LineUnavailableException
    {
        //what to do if there is a match (same character added more than once)
        boolean matchFound = false;
        
        for (int i = 0; i < wordInPlayArray.length; i++)
        {
            if (wordInPlayArray[i] == holdChar)
            {
                boardInPlayArray[i] = holdChar;
                matchFound = true;
                s.playMatchSound();
            }
        }
        if (matchFound == false)
        {
            s.playNoMatchSound();
            badGuessArray.add(holdChar);
            guessCounter++;
            System.out.println("Guesses Remaining: " + (MAX_GUESSES - guessCounter));
        }
    }
    
    public void displayGameBoard()
    {
        //the display for the game itself.
        for (int i = 0; i < wordInPlayArray.length; i++)
        {
            System.out.print("*" + boardInPlayArray[i] + "*" + " ");
        }
    }
    
    public void checkForWinner() throws LineUnavailableException, InterruptedException, IOException
    {
        //where the game will check if there is a winner for the game.
        if (Arrays.equals(wordInPlayArray, boardInPlayArray))
        {
            Thread.sleep(1000);
            System.out.println("\nYou Guessed the word!");
            s.playWinnerSound();
            System.out.println("Do you want to play again? y or n?");
            a.goodbye();
        }
    }
    
    public void displayBadGuesses()
    {
        //what will happen if there are bad guesses and where how will be displayed.
        System.out.print("\t\t\t\t\tBad Guesses: ");
        
        for (char letter : badGuessArray)
        {
            System.out.print(letter + ", ");
        }
    }
}
