//Serena Bailey ITDEV110 Downtown Campus
package bailey_guesstheword;

import java.awt.Toolkit;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.*;

public class Sounder {

    public float SAMPLE_RATE = 8000f;

    public void playMatchSound() throws LineUnavailableException
    {
        //play this sound if there is a match for a guessed letter
        tone(1000,200);
        tone(2000,200);
    }

    public void playNoMatchSound() throws LineUnavailableException
    {
        //play this sound if there is no matched letter
        tone(300,100);
        tone(300,100);
    }
    public void playAlreadyGuessedSound() throws LineUnavailableException
    {
        //play this sound if a letter has already been guessed
        tone(350,70);
        tone(350,70);
        tone(350,70);
        tone(350,70);
        tone(350,70);
    }

    public void playLoserSound() throws LineUnavailableException
    {
        //play this sound if the game is lost
        tone(392,100);
        tone(392,100);
        tone(392,100);
        tone(392,100);
        tone(392,100);
    }

    public void playWinnerSound() throws LineUnavailableException
    {
        //play this sound if the user wins the game
        tone(2000,200);
        tone(1000,200);
        tone(2000,200);
        tone(1000,200);
        tone(2000,200);
        tone(1000,200);
        tone(2000,200);
        tone(587,50);
        tone(659,50);
        tone(698,50);
        tone(784,50);
        tone(1000,100);
    }
    public void start() throws LineUnavailableException
    {
        //the sound when starting the game
        tone(587,50);
        tone(659,50);
        tone(698,50);
        tone(784,50);
        tone(1000,100);
    }
    
    public void goodbye() throws LineUnavailableException
    {
        //the sound when ending the game
        tone(350,70);
        tone(350,70);
        tone(350,70);
        tone(350,70);
        tone(350,70);
    }
  public void tone(int hz, int msecs) 
     throws LineUnavailableException 
  {
     tone(hz, msecs, 1.0);
  }
  
  public void tone(int hz, int msecs, double vol) throws LineUnavailableException 
  {
    byte[] buf = new byte[1];
    AudioFormat af = 
        new AudioFormat(
            SAMPLE_RATE, // sampleRate
            8,           // sampleSizeInBits
            1,           // channels
            true,        // signed
            false);      // bigEndian
    SourceDataLine sdl = AudioSystem.getSourceDataLine(af);
    sdl.open(af);
    sdl.start();
    
    for (int i=0; i < msecs*8; i++) {
      double angle = i / (SAMPLE_RATE / hz) * 2.0 * Math.PI;
      buf[0] = (byte)(Math.sin(angle) * 127.0 * vol);
      sdl.write(buf,0,1);
    }
    sdl.drain();
    sdl.stop();
    sdl.close();
    }
}
